VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Capacitance Meter over USB"
   ClientHeight    =   2055
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   7170
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2055
   ScaleWidth      =   7170
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox txtB 
      Alignment       =   1  'Right Justify
      Height          =   375
      Left            =   3480
      TabIndex        =   3
      Text            =   "0"
      Top             =   1320
      Width           =   735
   End
   Begin VB.TextBox txtM 
      Alignment       =   1  'Right Justify
      Height          =   375
      Left            =   3480
      TabIndex        =   2
      Text            =   "0"
      Top             =   840
      Width           =   735
   End
   Begin VB.CommandButton cmdSample 
      Caption         =   "Sample"
      Height          =   495
      Left            =   600
      TabIndex        =   1
      Top             =   1320
      Width           =   975
   End
   Begin VB.Label lbl2 
      Caption         =   "Capacitance in uF"
      Height          =   255
      Left            =   5280
      TabIndex        =   10
      Top             =   600
      Width           =   1455
   End
   Begin VB.Label lblCapacitance 
      Alignment       =   1  'Right Justify
      BackColor       =   &H80000005&
      BorderStyle     =   1  'Fixed Single
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   5280
      TabIndex        =   9
      Top             =   840
      Width           =   1455
   End
   Begin VB.Label lblTime 
      Alignment       =   1  'Right Justify
      BackColor       =   &H80000005&
      BorderStyle     =   1  'Fixed Single
      Height          =   375
      Left            =   360
      TabIndex        =   8
      Top             =   720
      Width           =   1455
   End
   Begin VB.Label Label1 
      Caption         =   "Charge time in Seconds"
      Height          =   255
      Left            =   240
      TabIndex        =   7
      Top             =   480
      Width           =   1695
   End
   Begin VB.Line Line4 
      X1              =   2640
      X2              =   4440
      Y1              =   480
      Y2              =   480
   End
   Begin VB.Line Line3 
      X1              =   4440
      X2              =   4440
      Y1              =   1800
      Y2              =   480
   End
   Begin VB.Line Line2 
      X1              =   2640
      X2              =   4440
      Y1              =   1800
      Y2              =   1800
   End
   Begin VB.Line Line1 
      X1              =   2640
      X2              =   2640
      Y1              =   480
      Y2              =   1800
   End
   Begin VB.Label Label6 
      Caption         =   "Linear Equation Input"
      Height          =   255
      Left            =   2760
      TabIndex        =   6
      Top             =   600
      Width           =   1575
   End
   Begin VB.Label Label5 
      Caption         =   "b ="
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   3000
      TabIndex        =   5
      Top             =   1440
      Width           =   375
   End
   Begin VB.Label Label4 
      Caption         =   "m ="
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   3000
      TabIndex        =   4
      Top             =   960
      Width           =   375
   End
   Begin VB.Label lblUserArea 
      AutoSize        =   -1  'True
      Height          =   195
      Left            =   2040
      TabIndex        =   0
      Top             =   4560
      Width           =   45
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim glngHandle As Long
'
Public Enum DeviceStatus
    FT_OK
End Enum
'
Private Declare Function FT_Open Lib "FTD2XX.DLL" (ByVal intDeviceNumber As Integer, ByRef lngHandle As Long) As Long
Private Declare Function FT_Close Lib "FTD2XX.DLL" (ByVal lngHandle As Long) As Long
Private Declare Function FT_Write Lib "FTD2XX.DLL" (ByVal lngHandle As Long, ByVal lpszBuffer As String, ByVal lngBufferSize As Long, ByRef lngbyteswritten As Long) As Long
Private Declare Function FT_SetBitMode Lib "FTD2XX.DLL" (ByVal lngHandle As Long, ByVal ucMask As Byte, ByVal ucEnable As Byte) As Long
Private Declare Function FT_GetBitMode Lib "FTD2XX.DLL" (ByVal lngHandle As Long, ByVal pucMode As String) As Long

Private Sub form_unload(Cancel As Integer)
    Dim lngStatus As Long
    Dim lngClose As Long
'
    lngStatus = FT_SetBitMode(glngHandle, 0, 0)  'disable bit bang mode
    If lngStatus <> FT_OK Then
        MsgBox ("Error terminating Bit-Bang mode.")
    End If
'
    lngClose = FT_Close(glngHandle)
    If lngClose <> FT_OK Then
        MsgBox ("Error closing device")
    Else
        MsgBox ("Device closed")
    End If
    Unload Me
End Sub

Private Sub cmdSample_Click()
    Dim lngStatus As Long
    Dim strData As String * 256
    Dim lngbyteswritten As Long
    Dim data As Byte
    Dim t1, t2, b, m, x, y
'
    lblCapacitance.Caption = ""
    lblTime.Caption = "Processing!"
    lblTime.Refresh
'
    lngStatus = FT_SetBitMode(glngHandle, &HFD, &HFF)
    lngStatus = FT_Write(glngHandle, &H1, 1, lngbyteswritten)
    lngStatus = FT_Write(glngHandle, &H5, 1, lngbyteswritten)
    lngStatus = FT_Write(glngHandle, &H4, 1, lngbyteswritten)
    lngStatus = FT_Write(glngHandle, &H5, 1, lngbyteswritten)
'
    t1 = Timer
11  lngStatus = FT_GetBitMode(glngHandle, strData)
    data = strData And 2
    If data = 2 Then GoTo 11
    t2 = Timer
    x = t2 - t1
    lblTime.Caption = x
    m = Val(txtM)
    If m = 0 Then
        lblCapacitance.Caption = "No Data!"
        lblCapacitance.Refresh
    Else
        b = Val(txtB)
        y = (m * x) + b
        lblCapacitance.Caption = Format(y, "##.######")
    End If
End Sub

Private Sub Form_Load()
    If FT_Open(0, glngHandle) <> FT_OK Then
        MsgBox ("Error: Could not open the device.  Check the USB cable and power connection, then restart program.")
    Else
        MsgBox ("Device opened.")
    End If
End Sub


